import React from "react"
import PropTypes from "prop-types"
import User from './User.js'
import UserForm from './UserForm.js'

class HelloWorld extends React.Component {
  constructor(props, context){
    super(props, context)

    this.state = {
      users: this.props.users,
      first_name: '',
      last_name: ''
    }
  }

  handleUserInput = (obj) => {
    this.setState(obj)
  }

  handleFormSubmit = () => {
    var user = { first_name: this.state.first_name, last_name: this.state.last_name }
    // {user: { first_name: value, last_name: value}}
    fetch('/users', {
      method: 'POST',
      headers: {'Content-Type': 'application/json'},
      mode: 'same-origin',
      body: JSON.stringify({ user: user })
    }).then(function(response){
      return response.json()
    }).then(function(j){
      this.addNewUser(j)
    }.bind(this))
  }

  addNewUser = (user) => {
    var users = this.state.users.concat([user]).sort(function(a,b) {
      return new Date(b.created_at) - new Date(a.created_at)
    })
    this.setState({ users: users })
  }

  render () {
    return (
      <div>
        { this.state.users.map(function(user){
          return (
            <User key={user.id} user={user} />
          );
        })}
        <UserForm key='UserForm' 
          onUserInput={this.handleUserInput}
          onFormSubmit={this.handleFormSubmit}
        />
      </div>
    );
  }
}

export default HelloWorld
